SystemOrganization addCategory: #CSA!
SystemOrganization addCategory: #'CSA-Events'!
SystemOrganization addCategory: #'CSA-Metrics'!
SystemOrganization addCategory: #'CSA-UI'!
SystemOrganization addCategory: #'CSA-Test'!

Trait named: #TCSAEventHandler
	uses: {}
	category: 'CSA-Events'!

!TCSAEventHandler methodsFor: 'class events' stamp: 'sk 12/16/2011 21:41:00.595'!
addedClass: aCSAClassAddedEvent
	^ self doDefaultHandlingFor: aCSAClassAddedEvent! !

!TCSAEventHandler methodsFor: 'method events' stamp: 'sk 12/16/2011 23:28:43.042'!
addedMethod: aCSAMethodAddedEvent
	^ self doDefaultHandlingFor: aCSAMethodAddedEvent! !

!TCSAEventHandler methodsFor: 'general handling' stamp: 'sk 12/16/2011 21:40:23.582'!
doDefaultHandlingFor: aCSAEvent
	self requirement! !

!TCSAEventHandler methodsFor: 'general handling' stamp: 'sk 12/16/2011 23:41:19.443'!
handle: aCSAEvent
	^ aCSAEvent accept: self! !

!TCSAEventHandler methodsFor: 'class events' stamp: 'sk 12/17/2011 15:58:42.746'!
modifiedClass: aCSAClassModifiedEvent
	^ self doDefaultHandlingFor: aCSAClassModifiedEvent  ! !

!TCSAEventHandler methodsFor: 'method events' stamp: 'sk 12/17/2011 00:03:19.198'!
modifiedMethod: aCSAMethodChangedEvent
	^ self doDefaultHandlingFor: aCSAMethodChangedEvent  ! !

!TCSAEventHandler methodsFor: 'class events' stamp: 'sk 12/17/2011 16:09:42.133'!
recategorizedClass: aCSAClassRecategorizedEvent
	^ self doDefaultHandlingFor: aCSAClassRecategorizedEvent  ! !

!TCSAEventHandler methodsFor: 'class events' stamp: 'sk 12/16/2011 21:42:15.194'!
removedClass: aCSAClassRemovedEvent
	^ self doDefaultHandlingFor: aCSAClassRemovedEvent   ! !

!TCSAEventHandler methodsFor: 'method events' stamp: 'sk 12/16/2011 23:42:31.492'!
removedMethod: aCSAMethodRemovedEvent
	^ self doDefaultHandlingFor: aCSAMethodRemovedEvent  ! !

!TCSAEventHandler methodsFor: 'class events' stamp: 'sk 12/16/2011 23:39:00.133'!
renamedClass: aCSAClassRenamedEvent
	^ self doDefaultHandlingFor: aCSAClassRenamedEvent   ! !

Object subclass: #CSAClassSource
	uses: TCSAEventHandler @ {#adjust:->#handle:}
	instanceVariableNames: 'classes'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CSA'!

CSAClassSource class
	uses: TCSAEventHandler classTrait
	instanceVariableNames: ''!

CSAClassSource subclass: #CSACategoryClassSource
	instanceVariableNames: 'wildcard'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CSA'!

!CSACategoryClassSource class methodsFor: 'as yet unclassified' stamp: 'sk 12/5/2011 12:03:00.362'!
for: aString
	^ self new
		wildcard: aString;
		yourself  ! !

!CSACategoryClassSource methodsFor: 'accessing' stamp: 'sk 12/17/2011 19:20:16.006'!
contains: aClass
	^ self containsCategory: aClass theNonMetaClass category  ! !

!CSACategoryClassSource methodsFor: 'accessing' stamp: 'sk 12/22/2011 22:00:58.66'!
containsCategory: aSymbol
	^ aSymbol
		ifNil: [ false ]
		ifNotNil: [ self wildcard match: aSymbol ]  ! !

!CSACategoryClassSource methodsFor: 'class events' stamp: 'sk 12/17/2011 19:31:15.09'!
modifiedClass: aCSAClassModifiedEvent
	^ (self contains: aCSAClassModifiedEvent oldClass)
		ifTrue: [ aCSAClassModifiedEvent ]
		ifFalse: [ nil ]! !

!CSACategoryClassSource methodsFor: 'class events' stamp: 'sk 12/17/2011 19:31:21.333'!
recategorizedClass: aCSAClassRecategorizedEvent
	| isContained wasContained |
	isContained := self containsCategory: aCSAClassRecategorizedEvent newCategory.
	wasContained := self containsCategory: aCSAClassRecategorizedEvent oldCategory.
	(isContained & wasContained) ifTrue:
		[ ^ aCSAClassRecategorizedEvent ] .
	(isContained & wasContained not) ifTrue:
		[ ^ CSAClassAddedEvent for: aCSAClassRecategorizedEvent movedClass].
	(isContained not & wasContained) ifTrue:   
		[ ^ CSAClassRemovedEvent for: aCSAClassRecategorizedEvent movedClass].
	^ nil! !

!CSACategoryClassSource methodsFor: 'class events' stamp: 'sk 12/17/2011 19:31:28.765'!
renamedClass: aCSAClassRecategorizedEvent
	^ (self contains: aCSAClassRecategorizedEvent movedClass)
		ifTrue: [ aCSAClassRecategorizedEvent ]
		ifFalse: [ nil ]    ! !

!CSACategoryClassSource methodsFor: 'accessing' stamp: 'sk 12/5/2011 11:59:27.41'!
wildcard
	^ wildcard! !

!CSACategoryClassSource methodsFor: 'accessing' stamp: 'sk 12/5/2011 11:59:27.438'!
wildcard: aString
	wildcard := aString
! !

!CSAClassSource methodsFor: 'class events' stamp: 'sk 12/17/2011 19:27:44.316'!
addedClass: aCSAClassAddedEvent
	^ (self contains: aCSAClassAddedEvent newClass)
		ifTrue: [ aCSAClassAddedEvent ]
		ifFalse: [ nil ]    ! !

!CSAClassSource methodsFor: 'method events' stamp: 'sk 12/17/2011 19:28:30.432'!
addedMethod: aCSAMethodAddedEvent
	^ (self contains: aCSAMethodAddedEvent method methodClass)
		ifTrue: [ aCSAMethodAddedEvent ]
		ifFalse: [ nil ]    ! !

!CSAClassSource methodsFor: 'accessing' stamp: 'f.z 1/2/2012 10:19:46.723'!
classes
	^ SmalltalkImage current allClasses select:
		[ :class | self contains: class ]! !

!CSAClassSource methodsFor: 'accessing' stamp: 'sk 12/6/2011 01:46:20.115'!
contains: aClass
"Tells whether this class source contains the given class."
	self subclassResponsibility! !

!CSAClassSource methodsFor: 'general handling' stamp: 'sk 12/17/2011 19:22:48.625'!
doDefaultHandlingFor: aCSAEvent
	^ nil! !

!CSAClassSource methodsFor: 'method events' stamp: 'sk 12/17/2011 19:28:10.818'!
modifiedMethod: aCSAMethodChangedEvent
	^ (self contains: aCSAMethodChangedEvent method methodClass)
		ifTrue: [ aCSAMethodChangedEvent ]
		ifFalse: [ nil ]    ! !

!CSAClassSource methodsFor: 'class events' stamp: 'sk 12/17/2011 19:27:52.812'!
removedClass: aCSAClassRemovedEvent
	^ (self contains: aCSAClassRemovedEvent removedClass)
		ifTrue: [ aCSAClassRemovedEvent ]
		ifFalse: [ nil ]    ! !

!CSAClassSource methodsFor: 'method events' stamp: 'sk 12/17/2011 19:28:20.197'!
removedMethod: aCSAMethodRemovedEvent
	^ (self contains: aCSAMethodRemovedEvent method methodClass)
		ifTrue: [ aCSAMethodRemovedEvent ]
		ifFalse: [ nil ]    ! !

CSAClassSource subclass: #CSASingleClassSource
	instanceVariableNames: 'containedClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CSA'!

!CSASingleClassSource class methodsFor: 'instance creation' stamp: 'sk 12/4/2011 23:23:46.152'!
for: aClass
	^ self new
		containedClass: aClass;
		yourself  ! !

!CSASingleClassSource methodsFor: 'accessing' stamp: 'sk 12/4/2011 22:42:31.441'!
containedClass
	^ containedClass! !

!CSASingleClassSource methodsFor: 'accessing' stamp: 'sk 12/4/2011 22:42:52.644'!
containedClass: aClass
	containedClass := aClass.! !

!CSASingleClassSource methodsFor: 'accessing' stamp: 'f.z 1/2/2012 10:21:42.556'!
contains: aClass
	^ aClass = containedClass! !

CSAClassSource subclass: #CSAWildcardClassSource
	instanceVariableNames: 'wildcard'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CSA'!

!CSAWildcardClassSource class methodsFor: 'instance creation' stamp: 'sk 12/5/2011 00:50:39.949'!
for: aString
	^ (self new)
		wildcard: aString;
		yourself   ! !

!CSAWildcardClassSource methodsFor: 'matching' stamp: 'sk 12/5/2011 13:09:38.033'!
contains: aClass
	^ self wildcard match: aClass asString! !

!CSAWildcardClassSource methodsFor: 'accessing' stamp: 'sk 12/5/2011 00:18:57.184'!
wildcard
	^ wildcard! !

!CSAWildcardClassSource methodsFor: 'accessing' stamp: 'sk 12/5/2011 00:18:57.207'!
wildcard: aString
	wildcard := aString 
! !

Object subclass: #CSAEvent
	instanceVariableNames: ''
	classVariableNames: 'DispatchTable'
	poolDictionaries: ''
	category: 'CSA-Events'!

CSAEvent subclass: #CSAClassAddedEvent
	instanceVariableNames: 'newClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CSA-Events'!

!CSAClassAddedEvent class methodsFor: 'instance creation' stamp: 'sk 12/17/2011 17:55:44.591'!
for: aClass
	^ self new
		newClass: aClass;
		yourself 
	! !

!CSAClassAddedEvent class methodsFor: 'instance creation' stamp: 'sk 12/17/2011 19:24:44.96'!
forSystemEvent: anAddedEvent
	^ self for: anAddedEvent item
	! !

!CSAClassAddedEvent methodsFor: 'visitor' stamp: 'sk 12/17/2011 19:29:30.024'!
accept: aTCSAEventHandler
	^ aTCSAEventHandler addedClass: self! !

!CSAClassAddedEvent methodsFor: 'accessing' stamp: 'sk 12/16/2011 15:25:53.415'!
newClass
	^ newClass! !

!CSAClassAddedEvent methodsFor: 'accessing' stamp: 'sk 12/16/2011 15:25:53.436'!
newClass: aClass
	newClass := aClass
! !

!CSAClassAddedEvent methodsFor: 'printing' stamp: 'sk 12/21/2011 22:32:26.035'!
printOn: aStream
	super printOn: aStream.
	aStream nextPutAll: '(', self newClass, ')'! !

CSAEvent subclass: #CSAClassModifiedEvent
	instanceVariableNames: 'newClass oldClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CSA-Events'!

!CSAClassModifiedEvent class methodsFor: 'instance creation' stamp: 'sk 12/17/2011 16:00:02.219'!
forSystemEvent: anEvent
	^ self new
		oldClass: anEvent oldItem;
		newClass: anEvent item;
		yourself        ! !

!CSAClassModifiedEvent methodsFor: 'visitor' stamp: 'sk 12/17/2011 15:58:59.26'!
accept: aTCSAEventHandler
	^ aTCSAEventHandler modifiedClass: self! !

!CSAClassModifiedEvent methodsFor: 'accessing' stamp: 'sk 12/17/2011 15:57:28.295'!
newClass
	^ newClass! !

!CSAClassModifiedEvent methodsFor: 'accessing' stamp: 'sk 12/17/2011 15:57:28.376'!
newClass: aClass
	newClass := aClass
! !

!CSAClassModifiedEvent methodsFor: 'accessing' stamp: 'sk 12/17/2011 15:57:28.378'!
oldClass
	^ oldClass! !

!CSAClassModifiedEvent methodsFor: 'accessing' stamp: 'sk 12/17/2011 15:57:28.395'!
oldClass: aClass
	oldClass := aClass
! !

!CSAClassModifiedEvent methodsFor: 'printing' stamp: 'sk 12/21/2011 22:33:04.15'!
printOn: aStream
	super printOn: aStream.
	aStream nextPutAll: '(', self oldClass, ' -> ', self newClass, ')'! !

CSAEvent subclass: #CSAClassRecategorizedEvent
	instanceVariableNames: 'movedClass oldCategory newCategory'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CSA-Events'!

!CSAClassRecategorizedEvent class methodsFor: 'as yet unclassified' stamp: 'sk 12/21/2011 22:37:55.545'!
forSystemEvent: aRecategorizedEvent
	^ self new
		oldCategory: aRecategorizedEvent oldCategory;
		newCategory: aRecategorizedEvent itemCategory;
		movedClass: aRecategorizedEvent item;
		yourself  ! !

!CSAClassRecategorizedEvent methodsFor: 'accessing' stamp: 'sk 12/17/2011 16:09:50.735'!
accept: aTCSEventHandler
	^ aTCSEventHandler recategorizedClass: self   ! !

!CSAClassRecategorizedEvent methodsFor: 'accessing' stamp: 'sk 12/17/2011 16:07:50.962'!
movedClass
	^ movedClass! !

!CSAClassRecategorizedEvent methodsFor: 'accessing' stamp: 'sk 12/17/2011 16:07:50.976'!
movedClass: aClass
	movedClass := aClass
! !

!CSAClassRecategorizedEvent methodsFor: 'accessing' stamp: 'sk 12/17/2011 16:07:50.997'!
newCategory
	^ newCategory! !

!CSAClassRecategorizedEvent methodsFor: 'accessing' stamp: 'sk 12/17/2011 16:07:51.002'!
newCategory: aSymbol
	newCategory := aSymbol
! !

!CSAClassRecategorizedEvent methodsFor: 'accessing' stamp: 'sk 12/17/2011 16:07:50.983'!
oldCategory
	^ oldCategory! !

!CSAClassRecategorizedEvent methodsFor: 'accessing' stamp: 'sk 12/17/2011 16:07:50.99'!
oldCategory: aSymbol
	oldCategory := aSymbol
! !

!CSAClassRecategorizedEvent methodsFor: 'as yet unclassified' stamp: 'sk 12/21/2011 22:33:53.633'!
printOn: aStream
	super printOn: aStream.
	aStream nextPutAll: '(', self movedClass, ': ', self oldCategory, ' -> ', self newCategory, ')'! !

CSAEvent subclass: #CSAClassRemovedEvent
	instanceVariableNames: 'removedClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CSA-Events'!

!CSAClassRemovedEvent class methodsFor: 'instance creation' stamp: 'sk 12/17/2011 17:53:19.271'!
for: aClass
	^ self new
		removedClass: aClass;
		yourself ! !

!CSAClassRemovedEvent class methodsFor: 'instance creation' stamp: 'sk 12/17/2011 19:41:19.118'!
forSystemEvent: aRemovedEvent
	^ self for: aRemovedEvent item! !

!CSAClassRemovedEvent methodsFor: 'visitor' stamp: 'sk 12/17/2011 19:22:22.471'!
accept: aTCSAEventHandler
	^ aTCSAEventHandler removedClass: self    ! !

!CSAClassRemovedEvent methodsFor: 'as yet unclassified' stamp: 'sk 12/21/2011 22:31:43.328'!
printOn: aStream
	super printOn: aStream.
	aStream nextPutAll: '(', self removedClass, ')'! !

!CSAClassRemovedEvent methodsFor: 'accessing' stamp: 'sk 12/16/2011 16:18:14.12'!
removedClass
	^ removedClass! !

!CSAClassRemovedEvent methodsFor: 'accessing' stamp: 'sk 12/16/2011 16:18:14.172'!
removedClass: anObject
	removedClass := anObject! !

CSAEvent subclass: #CSAClassRenamedEvent
	instanceVariableNames: 'renamedClass oldName newName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CSA-Events'!

!CSAClassRenamedEvent class methodsFor: 'instance creation' stamp: 'sk 12/17/2011 16:39:37.578'!
forSystemEvent: aRenamedEvent
	^ self new
		oldName: aRenamedEvent oldName;
		newName: aRenamedEvent newName;
		renamedClass: aRenamedEvent item;
		yourself             ! !

!CSAClassRenamedEvent methodsFor: 'visitor' stamp: 'sk 12/17/2011 16:38:20.047'!
accept: aTCSAEventHandler
	^ aTCSAEventHandler renamedClass: self    ! !

!CSAClassRenamedEvent methodsFor: 'accessing' stamp: 'sk 12/17/2011 16:34:11.969'!
newName
	^ newName! !

!CSAClassRenamedEvent methodsFor: 'accessing' stamp: 'sk 12/17/2011 16:34:11.981'!
newName: aSymbol
	newName := aSymbol
! !

!CSAClassRenamedEvent methodsFor: 'accessing' stamp: 'sk 12/17/2011 16:34:11.939'!
oldName
	^ oldName! !

!CSAClassRenamedEvent methodsFor: 'accessing' stamp: 'sk 12/17/2011 16:34:11.954'!
oldName: aSymbol
	oldName := aSymbol
! !

!CSAClassRenamedEvent methodsFor: 'printing' stamp: 'sk 12/22/2011 21:06:35.706'!
printOn: aStream
	super printOn: aStream.
	aStream nextPutAll: '(', self oldName, ' -> ', self newName, ')'! !

!CSAClassRenamedEvent methodsFor: 'accessing' stamp: 'sk 12/17/2011 16:34:11.863'!
renamedClass
	^ renamedClass! !

!CSAClassRenamedEvent methodsFor: 'accessing' stamp: 'sk 12/17/2011 16:34:11.918'!
renamedClass: aClass
	renamedClass := aClass
! !

!CSAEvent methodsFor: 'visitor' stamp: 'sk 12/16/2011 21:39:33.58'!
accept: aTCSAEventHandler
	self subclassResponsibility! !

CSAEvent subclass: #CSAMethodEvent
	instanceVariableNames: 'method protocol'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CSA-Events'!

CSAMethodEvent subclass: #CSAMethodAddedEvent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CSA-Events'!

!CSAMethodAddedEvent methodsFor: 'visitor' stamp: 'sk 12/16/2011 23:36:42.932'!
accept: aTCSAEventHandler
	^ aTCSAEventHandler addedMethod: self! !

!CSAMethodEvent class methodsFor: 'instance creation' stamp: 'sk 12/17/2011 00:52:10.698'!
forSystemEvent: anAddedEvent
	^ self new
		method: anAddedEvent item;
		protocol: anAddedEvent itemProtocol;    
		yourself 
	! !

!CSAMethodEvent methodsFor: 'accessing' stamp: 'sk 12/16/2011 23:27:41.556'!
method
	^ method! !

!CSAMethodEvent methodsFor: 'accessing' stamp: 'sk 12/16/2011 23:27:41.607'!
method: aCompiledMethod
	method := aCompiledMethod
! !

!CSAMethodEvent methodsFor: 'printing' stamp: 'sk 12/22/2011 21:11:32.827'!
printOn: aStream
	super printOn: aStream.
	aStream nextPutAll: '(', self method reference, ' in ', self protocol , ')'! !

!CSAMethodEvent methodsFor: 'accessing' stamp: 'sk 12/16/2011 23:27:41.618'!
protocol
	^ protocol! !

!CSAMethodEvent methodsFor: 'accessing' stamp: 'sk 12/16/2011 23:27:41.625'!
protocol: aSymbol
	protocol := aSymbol
! !

CSAMethodEvent subclass: #CSAMethodModifiedEvent
	instanceVariableNames: 'oldMethod'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CSA-Events'!

!CSAMethodModifiedEvent class methodsFor: 'as yet unclassified' stamp: 'sk 12/17/2011 00:06:10.01'!
forSystemEvent: aMethodModifiedMethod
	^ (super forSystemEvent: aMethodModifiedMethod)
		oldMethod: aMethodModifiedMethod oldItem;
		yourself
	! !

!CSAMethodModifiedEvent methodsFor: 'as yet unclassified' stamp: 'sk 12/17/2011 00:03:29.369'!
accept: aTCSAEventHandler
	^ aTCSAEventHandler modifiedMethod: self    ! !

!CSAMethodModifiedEvent methodsFor: 'accessing' stamp: 'sk 12/16/2011 23:43:49.029'!
oldMethod
	^ oldMethod! !

!CSAMethodModifiedEvent methodsFor: 'accessing' stamp: 'sk 12/16/2011 23:43:49.04'!
oldMethod: aCompiledMethod
	oldMethod := aCompiledMethod
! !

CSAMethodEvent subclass: #CSAMethodRemovedEvent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CSA-Events'!

!CSAMethodRemovedEvent methodsFor: 'as yet unclassified' stamp: 'sk 12/16/2011 23:42:42.109'!
accept: aTCSEventHandler
	^ aTCSEventHandler removedMethod: self  ! !

Object subclass: #CSAEventAction
	instanceVariableNames: 'eventKind itemKind methodSelector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CSA'!

!CSAEventAction class methodsFor: 'instance creation' stamp: 'f.z 1/2/2012 09:42:54.697'!
when: anItemKindSymbol changes: anEventKindSymbol send: aMethodSelector
	^ self new
		itemKind: anItemKindSymbol;
		eventKind: anEventKindSymbol;
		methodSelector: aMethodSelector;
		yourself      ! !

!CSAEventAction methodsFor: 'accessing' stamp: 'f.z 1/2/2012 09:40:23.881'!
eventKind
	^ eventKind! !

!CSAEventAction methodsFor: 'accessing' stamp: 'f.z 1/2/2012 09:40:23.924'!
eventKind: aSymbol
	eventKind := aSymbol
! !

!CSAEventAction methodsFor: 'accessing' stamp: 'f.z 1/2/2012 09:40:23.959'!
itemKind
	^ itemKind! !

!CSAEventAction methodsFor: 'accessing' stamp: 'f.z 1/2/2012 10:15:30.972'!
itemKind: aSymbol
	itemKind := aSymbol
! !

!CSAEventAction methodsFor: 'accessing' stamp: 'f.z 1/2/2012 09:40:24.007'!
methodSelector
	^ methodSelector! !

!CSAEventAction methodsFor: 'accessing' stamp: 'f.z 1/2/2012 09:40:24.03'!
methodSelector: aSymbol
	methodSelector := aSymbol
! !

!CSAEventAction methodsFor: 'notifying' stamp: 'f.z 1/2/2012 10:09:56.109'!
sendNotificationsTo: anEventDispatcher
	SystemChangeNotifier uniqueInstance
		notify: anEventDispatcher
		ofSystemChangesOfItem: self itemKind
		change: self eventKind
		using: self methodSelector! !

!CSAEventAction methodsFor: 'notifying' stamp: 'f.z 1/2/2012 10:17:21.678'!
stopNotifying: anEventDispatcher
	SystemChangeNotifier uniqueInstance noMoreNotificationsFor: anEventDispatcher  ! !

Object subclass: #CSAEventChange
	instanceVariableNames: 'type event'
	classVariableNames: 'DispatchTable'
	poolDictionaries: ''
	category: 'CSA'!

!CSAEventChange class methodsFor: 'as yet unclassified' stamp: 'sk 12/15/2011 16:51:02.415'!
changedType
	^ #changed! !

!CSAEventChange class methodsFor: 'as yet unclassified' stamp: 'sk 12/15/2011 16:51:12.449'!
discardedType
	^ #discarded! !

!CSAEventChange class methodsFor: 'as yet unclassified' stamp: 'sk 12/15/2011 16:50:45.629'!
unchangedType
	^ #unchanged! !

!CSAEventChange methodsFor: 'accessing' stamp: 'sk 12/15/2011 16:50:22.011'!
event
	^ event! !

!CSAEventChange methodsFor: 'accessing' stamp: 'sk 12/15/2011 16:50:22.021'!
event: aCSAEvent
	event := aCSAEvent
! !

!CSAEventChange methodsFor: 'accessing' stamp: 'sk 12/15/2011 16:53:08.964'!
isChangedType
	^ self type == self class changedType! !

!CSAEventChange methodsFor: 'accessing' stamp: 'sk 12/15/2011 16:52:37.928'!
isDiscardedType
	^ self type == self class discardedType! !

!CSAEventChange methodsFor: 'accessing' stamp: 'sk 12/15/2011 16:52:59.385'!
isUnchangedType
	^ self type == self class unchangedType! !

!CSAEventChange methodsFor: 'accessing' stamp: 'sk 12/15/2011 16:50:21.981'!
type
	^ type! !

!CSAEventChange methodsFor: 'accessing' stamp: 'sk 12/15/2011 16:50:21.997'!
type: aSymbol
	type := aSymbol
! !

Object subclass: #CSAEventDispatcher
	instanceVariableNames: 'metrics filters'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CSA'!

CSAEventDispatcher class
	instanceVariableNames: 'instances'!

CSAEventDispatcher class
	instanceVariableNames: 'instances'!

!CSAEventDispatcher class methodsFor: 'instance creation' stamp: 'sk 12/5/2011 17:21:34.597'!
for: aClassSource
	^ self with:
		(OrderedCollection new
			add: (CSAClassSourceFilter for: aClassSource);
			yourself) ! !

!CSAEventDispatcher class methodsFor: 'accessing' stamp: 'sk 12/5/2011 17:16:11.273'!
instances
	instances ifNil:[ instances := OrderedCollection new ].
	^ instances! !

!CSAEventDispatcher class methodsFor: 'instance creation' stamp: 'sk 12/5/2011 17:18:05.415'!
new
"New instances are registered to keep the gc from collecting them."
"Should be removed in the end!!"
	| instance |
	instance := super new.
	self instances add: instance.
	^ instance! !

!CSAEventDispatcher class methodsFor: 'registration' stamp: 'sk 12/5/2011 17:19:02.828'!
unregisterAllInstances

	self allInstancesDo:
		[:runner | runner unregisterAsObserver].
	self instances removeAll.! !

!CSAEventDispatcher class methodsFor: 'instance creation' stamp: 'f.z 11/30/2011 17:40:36.102'!
with: aCollectionOfFilters
	^ self new
		filters: aCollectionOfFilters;
		yourself! !

!CSAEventDispatcher methodsFor: 'accessing' stamp: 'f.z 11/30/2011 17:57:40.981'!
addFilter: aFilter
	self filters add: aFilter! !

!CSAEventDispatcher methodsFor: 'accessing' stamp: 'f.z 11/30/2011 18:10:53.894'!
addMetric: aMetric
	self metrics add: aMetric! !

!CSAEventDispatcher methodsFor: 'events' stamp: 'sk 12/14/2011 17:06:04.396'!
broadcast2: aBlock with: anEvent
	self metrics do:
		[ :metric | aBlock value: metric value: anEvent ]! !

!CSAEventDispatcher methodsFor: 'events' stamp: 'f.z 11/30/2011 18:05:02.694'!
broadcast: anEvent
	self metrics do:
		[ :metric | metric process: anEvent ]! !

!CSAEventDispatcher methodsFor: 'registering' stamp: 'sk 12/14/2011 17:02:24.775'!
classSource
	"TODO"! !

!CSAEventDispatcher methodsFor: 'events' stamp: 'sk 12/14/2011 19:23:38.956'!
dispatch2: anEvent
| csaEvent |
	csaEvent := self classSource process: (CSAEvent for: anEvent).
	self metrics allInstancesDo: [ :metric | metric process: csaEvent ]! !

!CSAEventDispatcher methodsFor: 'events' stamp: 'sk 12/5/2011 13:18:39.007'!
dispatch: anEvent
	(self isInterestedIn: anEvent)
		ifTrue: [ self broadcast: anEvent ]! !

!CSAEventDispatcher methodsFor: 'accessing' stamp: 'f.z 11/30/2011 17:41:25.871'!
filters
	^ filters! !

!CSAEventDispatcher methodsFor: 'accessing' stamp: 'f.z 11/30/2011 17:41:25.882'!
filters: aCollection
	filters := aCollection! !

!CSAEventDispatcher methodsFor: 'initialize' stamp: 'f.z 11/30/2011 18:11:24.374'!
initialize
	self 
		filters: OrderedCollection new;
		metrics: OrderedCollection new  ! !

!CSAEventDispatcher methodsFor: 'events' stamp: 'f.z 12/1/2011 11:16:16.375'!
isInterestedIn: anEvent
	^ self filters allSatisfy: [ :filter | filter isInterestedIn: anEvent ]  ! !

!CSAEventDispatcher methodsFor: 'accessing' stamp: 'f.z 11/30/2011 18:10:37.334'!
metrics
	^ metrics! !

!CSAEventDispatcher methodsFor: 'accessing' stamp: 'f.z 11/30/2011 18:10:37.376'!
metrics: aCollection
	metrics := aCollection
! !

!CSAEventDispatcher methodsFor: 'accessing' stamp: 'f.z 11/30/2011 17:18:36.245'!
notifier
	^ SystemChangeNotifier uniqueInstance! !

!CSAEventDispatcher methodsFor: 'registering' stamp: 'f.z 11/30/2011 17:26:42.102'!
registerAsObserver 
 "Erstmal alle Systemevents abholen und spter dispatchen"
	self notifier notify: self ofAllSystemChangesUsing: #dispatch:.! !

!CSAEventDispatcher methodsFor: 'registering' stamp: 'f.z 12/1/2011 11:20:26.823'!
unregisterAsObserver
	self notifier noMoreNotificationsFor: self! !

Object subclass: #CSAEventDispatcher2
	instanceVariableNames: 'metrics classSource'
	classVariableNames: 'Instances'
	poolDictionaries: ''
	category: 'CSA'!

!CSAEventDispatcher2 class methodsFor: 'actions' stamp: 'f.z 1/2/2012 09:47:48.446'!
actions
	^ self methodActions
		addAll: self classActions;
		yourself! !

!CSAEventDispatcher2 class methodsFor: 'actions' stamp: 'f.z 1/2/2012 10:01:24.516'!
classActions
	^ OrderedCollection new
		add: self classModifiedAction;
		add: self classRemovedAction;
		add: self classModifiedAction;
		add: self classRenamedAction;
		add: self classRecategorizedAction;
		yourself! !

!CSAEventDispatcher2 class methodsFor: 'actions' stamp: 'f.z 1/2/2012 09:59:03.249'!
classAddedAction
	^ CSAEventAction
		when: AbstractEvent classKind
		changes: AddedEvent changeKind
		send: #classAddedEvent:! !

!CSAEventDispatcher2 class methodsFor: 'actions' stamp: 'f.z 1/2/2012 09:58:39.473'!
classModifiedAction
	^ CSAEventAction
		when: AbstractEvent classKind
		changes: ModifiedEvent changeKind
		send: #classModifiedEvent:! !

!CSAEventDispatcher2 class methodsFor: 'actions' stamp: 'f.z 1/2/2012 10:00:09.35'!
classRecategorizedAction
	^ CSAEventAction
		when: AbstractEvent classKind
		changes: RecategorizedEvent changeKind
		send: #classRecategorizedEvent:! !

!CSAEventDispatcher2 class methodsFor: 'actions' stamp: 'f.z 1/2/2012 09:57:58.261'!
classRemovedAction
	^ CSAEventAction
		when: AbstractEvent classKind
		changes: RemovedEvent changeKind
		send: #classRemovedEvent:! !

!CSAEventDispatcher2 class methodsFor: 'actions' stamp: 'f.z 1/2/2012 09:59:38.618'!
classRenamedAction
	^ CSAEventAction
		when: AbstractEvent classKind
		changes: RenamedEvent changeKind
		send: #classRenamedEvent:! !

!CSAEventDispatcher2 class methodsFor: 'instance creation' stamp: 'sk 12/16/2011 16:27:15.627'!
for: aCSAClassSource
	^ self instances
		at: aCSAClassSource
		ifAbsentPut: 
			(self new
				classSource: aCSAClassSource;
				yourself)  ! !

!CSAEventDispatcher2 class methodsFor: 'actions' stamp: 'sk 12/17/2011 16:24:06.178'!
generateActions
	self actions do:
		[ :actionArray |
		self methodDict at: (actionArray at: 3) ifAbsent: 
			[ self compile: (actionArray at: 3), ' anEvent self error: ''Implement me!!'' ' ] ]! !

!CSAEventDispatcher2 class methodsFor: 'instance handling' stamp: 'sk 12/16/2011 16:25:26.753'!
instances
	Instances ifNil: [ Instances := Dictionary new ].
	^ Instances
! !

!CSAEventDispatcher2 class methodsFor: 'instance handling' stamp: 'sk 12/16/2011 16:25:26.874'!
instances: aDictionary
	Instances := aDictionary
! !

!CSAEventDispatcher2 class methodsFor: 'actions' stamp: 'f.z 1/2/2012 09:56:13.709'!
methodActions
	^ OrderedCollection new
		add: self methodModifiedAction;
		add: self methodRemovedAction;
		add: self methodAddedAction;
		yourself! !

!CSAEventDispatcher2 class methodsFor: 'actions' stamp: 'f.z 1/2/2012 09:55:26.68'!
methodAddedAction
	^ CSAEventAction
		when: AbstractEvent methodKind
		changes: AddedEvent changeKind
		send: #methodAddedEvent:! !

!CSAEventDispatcher2 class methodsFor: 'actions' stamp: 'f.z 1/2/2012 09:54:01.378'!
methodModifiedAction
	^ CSAEventAction 
		when: AbstractEvent methodKind
		changes: ModifiedEvent changeKind
		send: #methodModifiedEvent:! !

!CSAEventDispatcher2 class methodsFor: 'actions' stamp: 'f.z 1/2/2012 09:54:53.083'!
methodRemovedAction
	^ CSAEventAction
		when: AbstractEvent methodKind
		changes: RemovedEvent changeKind
		send: #methodRemovedEvent:! !

!CSAEventDispatcher2 class methodsFor: 'instance handling' stamp: 'sk 12/21/2011 21:29:36.799'!
removeAllInstances
	self allInstancesDo:
		[ :dispatcher | dispatcher dismiss ].
	self instances: nil.  ! !

!CSAEventDispatcher2 methodsFor: 'metrics' stamp: 'sk 12/22/2011 19:03:56.327'!
addMetric: aCSAMetricClass
	^ self metrics 
		at: aCSAMetricClass
		ifAbsent: 
			[self metrics 
				at: aCSAMetricClass 
				put: (aCSAMetricClass 
					for: self classSource 
					withSourceMetrics:  (self addRequiredMetricsFor: aCSAMetricClass))].! !

!CSAEventDispatcher2 methodsFor: 'metrics' stamp: 'sk 12/22/2011 19:03:43.854'!
addRequiredMetricsFor: aCSAMetricClass
	| requiredMetrics |
	requiredMetrics := Dictionary new.
	aCSAMetricClass requiredMetrics do:
		[ :metricClass |
		requiredMetrics
			at: metricClass
			put: (self addMetric: metricClass) ].
	^ requiredMetrics! !

!CSAEventDispatcher2 methodsFor: 'dispatching' stamp: 'sk 12/17/2011 16:43:00.849'!
classAddedEvent: anEvent
	self dispatch: (CSAClassAddedEvent forSystemEvent: anEvent)  ! !

!CSAEventDispatcher2 methodsFor: 'dispatching' stamp: 'sk 12/17/2011 16:29:08.037'!
classModifiedEvent: anEvent
	self dispatch: (CSAClassModifiedEvent forSystemEvent: anEvent)  ! !

!CSAEventDispatcher2 methodsFor: 'dispatching' stamp: 'sk 12/17/2011 16:29:41.697'!
classRecategorizedEvent: anEvent
	self dispatch: (CSAClassRecategorizedEvent forSystemEvent: anEvent)  ! !

!CSAEventDispatcher2 methodsFor: 'dispatching' stamp: 'sk 12/17/2011 15:55:02.96'!
classRemovedEvent: aRemovedEvent
	self dispatch: (CSAClassRemovedEvent forSystemEvent: aRemovedEvent)  ! !

!CSAEventDispatcher2 methodsFor: 'dispatching' stamp: 'sk 12/17/2011 16:42:14.56'!
classRenamedEvent: anEvent
	self dispatch: (CSAClassRenamedEvent forSystemEvent: anEvent)  ! !

!CSAEventDispatcher2 methodsFor: 'accessing' stamp: 'sk 12/16/2011 16:33:52.754'!
classSource
	^ classSource! !

!CSAEventDispatcher2 methodsFor: 'accessing' stamp: 'sk 12/16/2011 16:33:52.766'!
classSource: aCSAClassSource
	classSource := aCSAClassSource
! !

!CSAEventDispatcher2 methodsFor: 'initialize' stamp: 'sk 12/21/2011 21:29:26.21'!
dismiss
	self unregisterAsObserver.
	self metrics do:
		[ :metric | metric dismiss ]! !

!CSAEventDispatcher2 methodsFor: 'dispatching' stamp: 'sk 12/21/2011 22:28:04.894'!
dispatch: aCSAEvent
	(self classSource adjust: aCSAEvent) ifNotNilDo: 
		[ :event | 
		Transcript cr; show: 'dispatching ', aCSAEvent, ' -> ', event; cr.
		self metrics do: [ :metric | metric handle: event ] ]  
! !

!CSAEventDispatcher2 methodsFor: 'initialize' stamp: 'sk 12/16/2011 16:34:48.302'!
initialize
	super initialize.
	^ self
		initializeState;
		registerAsObserver;
		yourself ! !

!CSAEventDispatcher2 methodsFor: 'initialize' stamp: 'sk 12/16/2011 23:59:56.137'!
initializeState
	self metrics: Dictionary new.! !

!CSAEventDispatcher2 methodsFor: 'dispatching' stamp: 'sk 12/17/2011 15:53:44.475'!
methodAddedEvent: anAddedEvent
	self dispatch: (CSAMethodAddedEvent forSystemEvent: anAddedEvent)  ! !

!CSAEventDispatcher2 methodsFor: 'dispatching' stamp: 'sk 12/17/2011 15:37:34.821'!
methodModifiedEvent: aModifiedEvent
	self dispatch: (CSAMethodModifiedEvent forSystemEvent: aModifiedEvent)  ! !

!CSAEventDispatcher2 methodsFor: 'dispatching' stamp: 'sk 12/17/2011 15:54:41.877'!
methodRemovedEvent: aRemovedEvent
	self dispatch: (CSAMethodRemovedEvent forSystemEvent: aRemovedEvent)  ! !

!CSAEventDispatcher2 methodsFor: 'accessing' stamp: 'sk 12/16/2011 16:33:52.714'!
metrics
	^ metrics! !

!CSAEventDispatcher2 methodsFor: 'accessing' stamp: 'sk 12/16/2011 16:33:52.735'!
metrics: aCSAMetric
	metrics := aCSAMetric
! !

!CSAEventDispatcher2 methodsFor: 'initialize' stamp: 'sk 12/21/2011 21:43:22.263'!
refresh
	self metrics do:
		[ :metric |
		metric 
			initializeFrom: self classSource;
			updateWindow ]! !

!CSAEventDispatcher2 methodsFor: 'initialize' stamp: 'f.z 1/2/2012 10:10:30.186'!
registerAsObserver 
	self class actions do:
		[ :action | action sendNotificationsTo: self ]! !

!CSAEventDispatcher2 methodsFor: 'metrics' stamp: 'sk 12/22/2011 21:05:34.594'!
removeChildMetricsOf: aCSAMetric
	self metrics keysAndValuesDo:
		 [ :class :metric | (metric sourceMetrics includes: aCSAMetric)
			ifTrue: [ self removeMetric: class ] ]  ! !

!CSAEventDispatcher2 methodsFor: 'metrics' stamp: 'sk 12/22/2011 19:28:01.342'!
removeMetric: aCSAMetricClass
	| metric |
	metric := self metrics at: aCSAMetricClass ifAbsent: [ ^ self ].
	self removeChildMetricsOf: metric.
	metric dismiss.
	self metrics removeKey: aCSAMetricClass! !

!CSAEventDispatcher2 methodsFor: 'initialize' stamp: 'f.z 1/2/2012 10:11:56.039'!
unregisterAsObserver
	self class actions do:
		[ :action | action stopNotifying: self ]! !

Object subclass: #CSAEventFilter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CSA'!

CSAEventFilter subclass: #CSACategoryFilter
	instanceVariableNames: 'wildcardMatcher'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CSA'!

!CSACategoryFilter class methodsFor: 'instance creation' stamp: 'f.z 11/30/2011 18:18:56.023'!
for: aString
	^ self new
		wildcardMatcher: aString;
		yourself! !

!CSACategoryFilter methodsFor: 'filtering' stamp: 'f.z 12/1/2011 11:35:12.876'!
categoryFor: anEvent
	^ (self classFor: anEvent) category  ! !

!CSACategoryFilter methodsFor: 'filtering' stamp: 'f.z 12/1/2011 11:39:33.431'!
classFor: anEvent
	"Answers the class that the given event applies to. I am only interested in
	method and class events."
	anEvent itemKind = AbstractEvent classKind ifTrue: [ ^ anEvent item ].
	^ anEvent item methodClass! !

!CSACategoryFilter methodsFor: 'initialize' stamp: 'f.z 12/1/2011 11:41:30.311'!
initialize
	self wildcardMatcher: '*'! !

!CSACategoryFilter methodsFor: 'filtering' stamp: 'f.z 12/1/2011 11:33:58.648'!
isInterestedIn: anEvent
	(self isOfCorrectKind: anEvent)
		ifFalse: [ ^ false ].
	^ self wildcardMatcher match: (self categoryFor: anEvent)! !

!CSACategoryFilter methodsFor: 'filtering' stamp: 'f.z 12/1/2011 11:38:50.671'!
isOfCorrectKind: anEvent
	anEvent itemKind = AbstractEvent methodKind ifTrue: [ ^ true ].
	anEvent itemKind = AbstractEvent classKind ifTrue: [ ^ true ].
	^ false! !

!CSACategoryFilter methodsFor: 'accessing' stamp: 'f.z 11/30/2011 18:19:30.454'!
wildcardMatcher
	^ wildcardMatcher! !

!CSACategoryFilter methodsFor: 'accessing' stamp: 'f.z 11/30/2011 18:19:30.513'!
wildcardMatcher: aString
	wildcardMatcher := aString
! !

CSAEventFilter subclass: #CSAClassSourceFilter
	instanceVariableNames: 'source'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CSA'!

!CSAClassSourceFilter class methodsFor: 'instance creation' stamp: 'f.z 12/5/2011 16:35:53.095'!
for: aClassSource
	^ self new
		source: aClassSource;
		yourself! !

!CSAClassSourceFilter methodsFor: 'filtering' stamp: 'sk 12/5/2011 17:39:20.515'!
isInterestedIn: anEvent
	anEvent itemClass ifNil: [ ^ false ].
	(anEvent isModified 
		and: [anEvent itemKind == AbstractEvent classKind]
		and: [ self source contains: anEvent oldItem ])
		ifTrue: [ ^ true ].
	^ self source contains: anEvent itemClass! !

!CSAClassSourceFilter methodsFor: 'accessing' stamp: 'f.z 12/5/2011 16:36:08.598'!
source
	^ source! !

!CSAClassSourceFilter methodsFor: 'accessing' stamp: 'f.z 12/5/2011 16:36:08.614'!
source: aClassSource
	source := aClassSource
! !

!CSAEventFilter methodsFor: 'filtering' stamp: 'f.z 11/30/2011 18:14:04.134'!
isInterestedIn: anEvent
	self subclassResponsibility! !

CSAEventFilter subclass: #CSAFalseFilter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CSA-Test'!

!CSAFalseFilter methodsFor: 'filtering' stamp: 'f.z 12/1/2011 11:23:22.664'!
isInterestedIn: anEvent
	^ false! !

CSAEventFilter subclass: #CSATrueFilter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CSA-Test'!

!CSATrueFilter methodsFor: 'filtering' stamp: 'f.z 11/30/2011 17:53:10.886'!
isInterestedIn: anEvent
	^ true  ! !

Object subclass: #CSAMetric
	uses: TCSAEventHandler
	instanceVariableNames: 'window classSource sourceMetrics'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CSA-Metrics'!

CSAMetric class
	uses: TCSAEventHandler classTrait
	instanceVariableNames: ''!

CSAMetric subclass: #CSACombinedMetric
	instanceVariableNames: 'metricStore'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CSA-Metrics'!

!CSACombinedMetric class methodsFor: 'as yet unclassified' stamp: 'ck 12/31/2011 10:55:30.411'!
label
	self subclassResponsibility ! !

!CSACombinedMetric methodsFor: 'as yet unclassified' stamp: 'ck 12/31/2011 10:50:54.449'!
addedClass: aClassAddedEvent
	self introduceClass: aClassAddedEvent newClass! !

!CSACombinedMetric methodsFor: 'as yet unclassified' stamp: 'ck 12/31/2011 10:51:03.755'!
addedMethod: aMethodEvent  
	self updateWith: aMethodEvent method! !

!CSACombinedMetric methodsFor: 'as yet unclassified' stamp: 'ck 12/31/2011 11:04:56.131'!
at: aClass with: aMethodSelector put: aValue
	| classStore |
	classStore := self metricStore 
		at: aClass
		ifAbsent: 
			[ classStore := Dictionary new. 
			self metricStore at: aClass put: classStore ].
	classStore at: aMethodSelector put: aValue.! !

!CSACombinedMetric methodsFor: 'as yet unclassified' stamp: 'ck 12/31/2011 10:54:52.091'!
createWindow
	^ CSATextWindow 
		labelled: self class label 
		withColor: self class widgetColor ! !

!CSACombinedMetric methodsFor: 'as yet unclassified' stamp: 'ck 12/31/2011 10:54:14.441'!
formattedTextFor: aClass with: methodLOCs
	self subclassResponsibility ! !

!CSACombinedMetric methodsFor: 'as yet unclassified' stamp: 'ck 12/31/2011 10:30:50.707'!
initialize
	super initialize.
	self metricStore: Dictionary new.! !

!CSACombinedMetric methodsFor: 'as yet unclassified' stamp: 'ck 12/31/2011 10:49:45.325'!
initializeFrom: aCSAClassSource  
	aCSAClassSource classes do: [ :class | self introduceClass: class ]  ! !

!CSACombinedMetric methodsFor: 'as yet unclassified' stamp: 'ck 12/31/2011 10:50:41.851'!
introduceClass: aClass
	self metricStore 
		at: aClass 
		put: Dictionary new.
	aClass methodsDo: [:method | self updateWith: method ]! !

!CSACombinedMetric methodsFor: 'as yet unclassified' stamp: 'ck 12/31/2011 10:30:13.505'!
metricStore
	^ metricStore! !

!CSACombinedMetric methodsFor: 'as yet unclassified' stamp: 'ck 12/31/2011 10:30:08.455'!
metricStore: aDictionary
	metricStore := aDictionary ! !

!CSACombinedMetric methodsFor: 'as yet unclassified' stamp: 'ck 12/31/2011 10:51:36.839'!
modifiedMethod: aMethodEvent  
	self updateWith: aMethodEvent method! !

!CSACombinedMetric methodsFor: 'as yet unclassified' stamp: 'ck 12/31/2011 10:51:51.537'!
removedClass: aClassRemovedEvent
	self metricStore removeKey: aClassRemovedEvent removedClass name! !

!CSACombinedMetric methodsFor: 'as yet unclassified' stamp: 'ck 12/31/2011 10:52:09.675'!
removedMethod: aMethodEvent  
	| classMetric method|
	method := aMethodEvent method.
	classMetric := self metricStore at: method methodClass.
	classMetric removeKey: method selector! !

!CSACombinedMetric methodsFor: 'as yet unclassified' stamp: 'ck 12/31/2011 10:52:28.137'!
renamedClass: aClassRenamedEvent
	| metrics |
	metrics := self metricStore at: aClassRenamedEvent oldName.
	self metricStore removeKey: aClassRenamedEvent oldName.
	self metricStore at: aClassRenamedEvent newName put: metrics  ! !

!CSACombinedMetric methodsFor: 'as yet unclassified' stamp: 'ck 12/31/2011 10:58:25.365'!
updateWindow
	| text |
	text := ''.
	self metricStore keysAndValuesDo: 
		[:class :methodLOCs |
		text := text , (self formattedTextFor: class with: methodLOCs), String cr.].
	self window text: text.! !

!CSACombinedMetric methodsFor: 'as yet unclassified' stamp: 'ck 12/31/2011 10:47:43.533'!
updateWith: aCompiledMethod
	self subclassResponsibility   ! !

CSACombinedMetric subclass: #CSALinesOfCodeMetric2
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CSA-Metrics'!

!CSALinesOfCodeMetric2 class methodsFor: 'as yet unclassified' stamp: 'ck 12/31/2011 10:55:19.645'!
label
	 ^ 'LOC2'! !

!CSALinesOfCodeMetric2 class methodsFor: 'as yet unclassified' stamp: 'ck 12/30/2011 14:35:24.256'!
widgetColor 
	 ^ Color green muchDarker! !

!CSALinesOfCodeMetric2 methodsFor: 'as yet unclassified' stamp: 'ck 12/30/2011 11:00:56.908'!
formattedTextFor: aClass with: methodLOCs
	|average text|
	average := 0.
	text := ''.
	methodLOCs keysAndValuesDo: 
		[:methodSymbol :loc |
		average := average + loc.
		text := text,'     ', methodSymbol , ' (', loc asString, ')', String cr.	].
	methodLOCs isEmpty ifFalse: 
		[average := average / (methodLOCs size). ].
	^ aClass name, '(', (average asFloat roundTo: 0.01) asString ,')', ':', String cr, text.
! !

!CSALinesOfCodeMetric2 methodsFor: 'as yet unclassified' stamp: 'ck 12/29/2011 17:27:59.036'!
linesOfCodeFor: aCompiledMethod
	^ aCompiledMethod linesOfCode ! !

!CSALinesOfCodeMetric2 methodsFor: 'as yet unclassified' stamp: 'ck 12/31/2011 11:05:38.973'!
updateWith: aCompiledMethod
	self 
		at: aCompiledMethod methodClass 
		with: aCompiledMethod selector
		put: (self linesOfCodeFor: aCompiledMethod).  ! !

CSACombinedMetric subclass: #CSAMethodCycloMetric
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CSA-Metrics'!

!CSAMethodCycloMetric class methodsFor: 'as yet unclassified' stamp: 'ck 12/31/2011 10:56:37.957'!
label
	^ 'Cyclo'! !

!CSAMethodCycloMetric class methodsFor: 'as yet unclassified' stamp: 'ck 12/30/2011 15:48:09.464'!
widgetColor 
	^ Color blue muchLighter! !

!CSAMethodCycloMetric methodsFor: 'as yet unclassified' stamp: 'ck 12/31/2011 11:07:32.545'!
formattedTextFor: aClass with: methodCyclos
	|text|
	text := ''.
	methodCyclos keysAndValuesDo: 
		[:methodSymbol :cyclo |
		text := text,'     ', methodSymbol , ' (', cyclo asString, ')', String cr.	].
	^ aClass name, ':', String cr, text.! !

!CSAMethodCycloMetric methodsFor: 'as yet unclassified' stamp: 'ck 12/31/2011 11:09:43.367'!
nodeCYCLO: aNode
	"Taken from SLMethodMetricsPlugIn>>nodeCYLCO 
	Check statements for containing ifs etc. If necessary, recursively traverse the tree to find more."
	| cyclo statements |
	(aNode isMethod or: [aNode isBlock]) ifFalse: [^ 0].
	cyclo := 0.	
	statements := aNode body statements.
	statements do: [ :node | node isMessage ifTrue: [
			(SLMethodMetricsPlugIn ifAndSimilar includes: (node selector)) ifTrue: [
				cyclo := cyclo + 1.
				node arguments do: [ :anotherMethodNode | 
					cyclo := cyclo + (self nodeCYCLO: anotherMethodNode).]				
				]]].
	^ cyclo! !

!CSAMethodCycloMetric methodsFor: 'as yet unclassified' stamp: 'ck 12/31/2011 11:08:37.751'!
updateWith: aCompiledMethod
	"code taken from SLMethodMetricsPlugIn>>methodCYLCO"
	|methodnode cyclo|
	methodnode := RBParser parseMethod: (aCompiledMethod getSource asString).
	cyclo := 1 + (self nodeCYCLO: methodnode).
	self 
		at: aCompiledMethod methodClass 
		with: aCompiledMethod selector
		put: cyclo.  ! !

CSAMetric subclass: #CSAExploreMetric
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CSA-Metrics'!

!CSAExploreMetric methodsFor: 'event-processing' stamp: 'sk 12/17/2011 00:46:47.888'!
doDefaultHandlingFor: aCSAEvent
	aCSAEvent explore  ! !

!CSAExploreMetric methodsFor: 'as yet unclassified' stamp: 'sk 12/17/2011 19:50:59.156'!
initializeFrom: aCSAClassSource
	aCSAClassSource explore! !

CSAMetric subclass: #CSAInheritanceDepthMetric
	instanceVariableNames: 'depthCounter'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CSA-Metrics'!

!CSAInheritanceDepthMetric class methodsFor: 'as yet unclassified' stamp: 'sk 12/22/2011 16:02:40.426'!
widgetColor
	^ Color yellow muchDarker! !

!CSAInheritanceDepthMetric methodsFor: 'class events' stamp: 'sk 12/17/2011 20:14:43.021'!
addedClass: aCSAClassAddedEvent
	self countClass: aCSAClassAddedEvent newClass  ! !

!CSAInheritanceDepthMetric methodsFor: 'observing' stamp: 'sk 12/17/2011 20:34:28.491'!
averageDepth
	^ self classCount == 0 ifTrue: [ 0 ] ifFalse: [ self depthSum / self classCount ]! !

!CSAInheritanceDepthMetric methodsFor: 'observing' stamp: 'sk 12/21/2011 22:00:58.306'!
classCount
	^ self depthCounter size! !

!CSAInheritanceDepthMetric methodsFor: 'observing' stamp: 'sk 12/21/2011 23:02:31.624'!
countClass: aClass
	| depth |
	depth := self determineInheritenceDepth: aClass.
	depth >= 0 ifTrue: [ self depthCounter at: aClass name put: depth ].
	^ depth! !

!CSAInheritanceDepthMetric methodsFor: 'user interface' stamp: 'sk 12/22/2011 16:08:40.527'!
createWindow
	^ CSATextWindow labelled: 'Inheritance Depth' withColor: self class widgetColor! !

!CSAInheritanceDepthMetric methodsFor: 'accessing' stamp: 'sk 12/17/2011 19:49:55.589'!
depthCounter
	^ depthCounter! !

!CSAInheritanceDepthMetric methodsFor: 'accessing' stamp: 'sk 12/17/2011 19:49:55.641'!
depthCounter: aDictionary
	depthCounter := aDictionary
! !

!CSAInheritanceDepthMetric methodsFor: 'observing' stamp: 'sk 12/21/2011 22:01:26.89'!
depthSum
	^ self depthCounter values 
		inject: 0 
		into: [ :sum :depth | sum + depth ]! !

!CSAInheritanceDepthMetric methodsFor: 'observing' stamp: 'sk 12/17/2011 20:38:43.765'!
determineInheritenceDepth: aClass
	| depth curClass |
	depth := 0.
	curClass := aClass.
	[ curClass ~= Object ] whileTrue: 
		[ (curClass == nil) ifTrue: [ ^ -1 ].  
		curClass := curClass superclass.
		depth := depth + 1 ].
	^ depth   ! !

!CSAInheritanceDepthMetric methodsFor: 'initialize-release' stamp: 'sk 12/21/2011 21:00:50.979'!
initialize
	super initialize.
	self depthCounter: Dictionary new  ! !

!CSAInheritanceDepthMetric methodsFor: 'initialize-release' stamp: 'sk 12/21/2011 21:33:24.299'!
initializeFrom: aCSAClassSource
	aCSAClassSource classes do: [ :class | self countClass: class ]  
! !

!CSAInheritanceDepthMetric methodsFor: 'observing' stamp: 'sk 12/21/2011 22:00:27.406'!
maximumDepth
	^ self depthCounter values
		inject: 0
		into: [ :max :cur | max max: cur ]! !

!CSAInheritanceDepthMetric methodsFor: 'observing' stamp: 'sk 12/21/2011 22:45:43'!
minimumDepth
	^ self depthCounter 
		ifEmpty: [ 0 ]
	 	ifNotEmptyDo: 
			[ :counter | counter values
				inject: SmalltalkImage current allClasses size
				into: [ :min :cur | min min: cur ] ]
! !

!CSAInheritanceDepthMetric methodsFor: 'class events' stamp: 'sk 12/21/2011 23:20:10.961'!
modifiedClass: aClassModifiedEvent
	self updateDepthOf: (aClassModifiedEvent newClass)  ! !

!CSAInheritanceDepthMetric methodsFor: 'class events' stamp: 'sk 12/17/2011 20:14:53.424'!
removedClass: aCSAClassRemovedEvent
	self uncountClass: aCSAClassRemovedEvent removedClass  ! !

!CSAInheritanceDepthMetric methodsFor: 'observing' stamp: 'sk 12/21/2011 23:02:19.51'!
uncountClass: aClass
	^ self depthCounter removeKey: aClass name! !

!CSAInheritanceDepthMetric methodsFor: 'observing' stamp: 'sk 12/21/2011 23:19:46.565'!
updateDepthOf: aClass
	(self uncountClass: aClass) ~= (self countClass: aClass) ifTrue:
		[ aClass subclassesDo: 
			[ :subclass | 
			(self depthCounter keys contains: [ :key | key == subclass name ]) 
				ifTrue: [ self updateDepthOf: subclass ]  ]  ]! !

!CSAInheritanceDepthMetric methodsFor: 'user interface' stamp: 'sk 12/21/2011 21:50:05.605'!
updateWindow
	self window text: 'Min depth: ', self minimumDepth, String cr,
		'Max depth: ', self maximumDepth, String cr,
		'Average depth: ', (self averageDepth asFloat roundTo: 0.01)! !

CSAMetric subclass: #CSALinesOfCodeMetric
	instanceVariableNames: 'linesOfCode'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CSA-Metrics'!

!CSALinesOfCodeMetric class methodsFor: 'as yet unclassified' stamp: 'sk 12/22/2011 16:03:01.866'!
widgetColor
	^ Color green! !

!CSALinesOfCodeMetric methodsFor: 'class events' stamp: 'sk 12/22/2011 14:00:36.448'!
addedClass: aCSAClassAddedEvent
	self countClass: aCSAClassAddedEvent newClass  ! !

!CSALinesOfCodeMetric methodsFor: 'method events' stamp: 'sk 12/22/2011 14:01:18.485'!
addedMethod: aCSAMethodAddedEvent
	self countMethod: aCSAMethodAddedEvent method  ! !

!CSALinesOfCodeMetric methodsFor: 'observing' stamp: 'sk 12/22/2011 14:00:13.744'!
countClass: aClass
	aClass methodDict valuesDo: [ :method | self countMethod:  method ]! !

!CSALinesOfCodeMetric methodsFor: 'observing' stamp: 'sk 12/22/2011 13:58:23.67'!
countMethod: aCompiledMethod
	self linesOfCode: self linesOfCode + aCompiledMethod linesOfCode    ! !

!CSALinesOfCodeMetric methodsFor: 'user interface' stamp: 'sk 12/22/2011 16:08:32.007'!
createWindow
	^ CSATextWindow labelled: 'LOC' withColor: self class widgetColor! !

!CSALinesOfCodeMetric methodsFor: 'initialize' stamp: 'sk 12/22/2011 11:46:13.592'!
initialize
	super initialize.  
	self linesOfCode: 0  ! !

!CSALinesOfCodeMetric methodsFor: 'initialize' stamp: 'f.z 12/5/2011 16:15:28.663'!
initializeFrom: aClassSource
	self linesOfCode:
		(aClassSource classes 
			inject: 0 into: [ :sum :class | sum + class linesOfCode])! !

!CSALinesOfCodeMetric methodsFor: 'accessing' stamp: 'f.z 12/5/2011 16:06:43.078'!
linesOfCode
	^ linesOfCode! !

!CSALinesOfCodeMetric methodsFor: 'accessing' stamp: 'f.z 12/5/2011 16:06:43.092'!
linesOfCode: anInteger
	linesOfCode := anInteger
! !

!CSALinesOfCodeMetric methodsFor: 'event-processing' stamp: 'f.z 12/5/2011 16:32:12.201'!
linesOfCodeDifferenceFor: aModifiedEvent
	^ aModifiedEvent item linesOfCode - aModifiedEvent oldItem linesOfCode ! !

!CSALinesOfCodeMetric methodsFor: 'method events' stamp: 'sk 12/22/2011 14:02:14.22'!
modifiedMethod: aCSAMethodModifiedEvent
	self
		uncountMethod: aCSAMethodModifiedEvent oldMethod;     
		countMethod: aCSAMethodModifiedEvent method! !

!CSALinesOfCodeMetric methodsFor: 'class events' stamp: 'sk 12/22/2011 14:29:11.094'!
removedClass: aCSAClassRemovedEvent
	self uncountClass: aCSAClassRemovedEvent removedClass  ! !

!CSALinesOfCodeMetric methodsFor: 'method events' stamp: 'sk 12/22/2011 14:02:56.824'!
removedMethod: aCSAMethodRemovedEvent
	self	uncountMethod: aCSAMethodRemovedEvent method! !

!CSALinesOfCodeMetric methodsFor: 'observing' stamp: 'sk 12/22/2011 14:00:01.2'!
uncountClass: aClass
	aClass methodDict valuesDo: [ :method | self uncountMethod:  method ]! !

!CSALinesOfCodeMetric methodsFor: 'observing' stamp: 'sk 12/22/2011 13:58:35.085'!
uncountMethod: aCompiledMethod
	self linesOfCode: self linesOfCode - aCompiledMethod linesOfCode    ! !

!CSALinesOfCodeMetric methodsFor: 'user interface' stamp: 'sk 12/22/2011 11:44:10.619'!
updateWindow
	self window text: 'LOC: ', self linesOfCode  ! !

CSAMetric subclass: #CSALinesPerMethodMetrics
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CSA-Metrics'!

!CSALinesPerMethodMetrics class methodsFor: 'as yet unclassified' stamp: 'sk 12/22/2011 19:17:34.537'!
requiredMetrics
	^ {CSANumberOfMethodsMetric . CSALinesOfCodeMetric}! !

!CSALinesPerMethodMetrics class methodsFor: 'as yet unclassified' stamp: 'sk 12/22/2011 21:03:58.576'!
widgetColor
	^ Color magenta muchDarker ! !

!CSALinesPerMethodMetrics methodsFor: 'as yet unclassified' stamp: 'sk 12/22/2011 21:03:52.696'!
createWindow
	^ CSATextWindow labelled: '' withColor: self class widgetColor! !

!CSALinesPerMethodMetrics methodsFor: 'as yet unclassified' stamp: 'sk 12/22/2011 19:21:54.612'!
initializeFrom: aCSAClassSource
	"Let the source metrics do the work"  ! !

!CSALinesPerMethodMetrics methodsFor: 'as yet unclassified' stamp: 'sk 12/22/2011 21:52:25.608'!
linesPerMethod
	| methods |
	methods := self nomMetric methodCount.
	^ methods isZero
		ifFalse: [ self locMetric linesOfCode / methods ]
		ifTrue: [ 0 ]    ! !

!CSALinesPerMethodMetrics methodsFor: 'as yet unclassified' stamp: 'sk 12/22/2011 19:07:05.622'!
locMetric
	^ self sourceMetrics at: CSALinesOfCodeMetric! !

!CSALinesPerMethodMetrics methodsFor: 'as yet unclassified' stamp: 'sk 12/22/2011 19:07:23.22'!
nomMetric
	^ self sourceMetrics at: CSANumberOfMethodsMetric! !

!CSALinesPerMethodMetrics methodsFor: 'as yet unclassified' stamp: 'sk 12/22/2011 19:24:13.352'!
updateWindow
	self window text: 'LPM: ', (self linesPerMethod asFloat roundTo: 0.01)! !

CSAMetric subclass: #CSAMethodMetric
	instanceVariableNames: 'analysedMethod'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CSA'!

!CSAMethodMetric methodsFor: 'accessing' stamp: 'ck 12/4/2011 22:00:49.388'!
analysedMethod
	^ analysedMethod! !

!CSAMethodMetric methodsFor: 'accessing' stamp: 'ck 12/4/2011 22:00:49.4'!
analysedMethod: anCompiledMethod
	analysedMethod := anCompiledMethod
! !

!CSAMethodMetric methodsFor: 'metrics' stamp: 'ck 12/4/2011 23:33:26.072'!
hasComment
	"relies on the convention, that the method comment is in the second line of the source code"
	| comment |
	comment := (analysedMethod getSource asString lines at: 2) withBlanksTrimmed.
	^ comment matchesRegex: '\"..*\"'! !

!CSAMethodMetric methodsFor: 'event-processing' stamp: 'f.z 12/5/2011 15:13:06.52'!
isInterestedIn: anEvent
	
	  	anEvent itemKind = AbstractEvent methodKind
		ifTrue: 
			[ ^ anEvent isModified ].
		^ False
		! !

!CSAMethodMetric methodsFor: 'metrics' stamp: 'ck 12/4/2011 23:26:16.55'!
linesOfCode
		
		^ analysedMethod  linesOfCode! !

!CSAMethodMetric methodsFor: 'metrics' stamp: 'ck 12/4/2011 23:27:12.534'!
numberOfArguments
	
	^ analysedMethod  numArgs! !

!CSAMethodMetric methodsFor: 'metrics' stamp: 'ck 12/4/2011 23:32:53.872'!
numberOfTemporaries
	"gives the number of temporaries including the arguments"
	^ analysedMethod  numTemps! !

!CSAMethodMetric methodsFor: 'metrics' stamp: 'ck 12/4/2011 23:29:44.134'!
overridesMethod
	^ analysedMethod sourceClass allSuperclasses anySatisfy: 
			[:class | class methodDict anySatisfy:   
				[:method | method selector name = analysedMethod selector name]]! !

!CSAMethodMetric methodsFor: 'event-processing' stamp: 'ck 12/4/2011 23:31:56.288'!
process: anEvent

	(self isInterestedIn: anEvent)   
		ifTrue: [ 
			self analysedMethod: anEvent item.
			self 
				hasComment;
				linesOfCode;
				numberOfTemporaries;
				numberOfArguments;
				overridesMethod;
				sendsMessages;
				sendsSuper;
				usedInstanceVariables   ]! !

!CSAMethodMetric methodsFor: 'metrics' stamp: 'ck 12/4/2011 23:26:53.714'!
sendsMessages 
	
	^ analysedMethod  messages! !

!CSAMethodMetric methodsFor: 'metrics' stamp: 'ck 12/4/2011 23:26:34.334'!
sendsSuper

		^ analysedMethod  sendsToSuper! !

!CSAMethodMetric methodsFor: 'metrics' stamp: 'ck 12/4/2011 23:29:22.662'!
usedInstanceVariables
	| allInstanceVariables |
	allInstanceVariables := analysedMethod sourceClass allInstVarNames.
	^ allInstanceVariables select: 
			[:variable | 
				analysedMethod readsField: 
					(allInstanceVariables indexOf: variable) ]! !

CSAMetric subclass: #CSAMethodsPerClassMetric
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CSA-Metrics'!

!CSAMethodsPerClassMetric class methodsFor: 'as yet unclassified' stamp: 'sk 12/22/2011 20:58:16.14'!
requiredMetrics
	^ { CSANumberOfMethodsMetric . CSANumberOfClassesMetric}! !

!CSAMethodsPerClassMetric class methodsFor: 'as yet unclassified' stamp: 'sk 12/22/2011 21:03:07.428'!
widgetColor
	^ Color brown! !

!CSAMethodsPerClassMetric methodsFor: 'user interface' stamp: 'sk 12/22/2011 21:01:08.709'!
createWindow
	^ CSATextWindow labelled: '' withColor: Color brown   ! !

!CSAMethodsPerClassMetric methodsFor: 'initialize-release' stamp: 'sk 12/22/2011 20:55:27.974'!
initializeFrom: aCSAClassSource  ! !

!CSAMethodsPerClassMetric methodsFor: 'as yet unclassified' stamp: 'sk 12/22/2011 20:56:25.635'!
methodsPerClass
	^ self nomMetric methodCount / self nocMetric classCount! !

!CSAMethodsPerClassMetric methodsFor: 'as yet unclassified' stamp: 'sk 12/22/2011 20:40:33.202'!
nocMetric
	^ self sourceMetrics at: CSANumberOfClassesMetric ! !

!CSAMethodsPerClassMetric methodsFor: 'as yet unclassified' stamp: 'sk 12/22/2011 20:40:51.978'!
nomMetric
	^ self sourceMetrics at: CSANumberOfMethodsMetric ! !

!CSAMethodsPerClassMetric methodsFor: 'user interface' stamp: 'sk 12/22/2011 20:59:30.593'!
updateWindow 
	self window text: 'MPC: ', (self methodsPerClass asFloat roundTo: 0.01)! !

!CSAMetric class methodsFor: 'instance creation' stamp: 'sk 12/22/2011 18:40:09.996'!
for: aCSAClassSource
	^ self for: aCSAClassSource withSourceMetrics: Dictionary new! !

!CSAMetric class methodsFor: 'instance creation' stamp: 'sk 12/22/2011 19:21:00.511'!
for: aCSAClassSource withSourceMetrics: aDictionary
	"We could do a sanity check at this point"
	^ self new
		sourceMetrics: aDictionary;  
		classSource: aCSAClassSource;
		openWindow;
		yourself! !

!CSAMetric class methodsFor: 'instance creation' stamp: 'sk 12/22/2011 19:17:02.093'!
requiredMetrics
	^ {}! !

!CSAMetric class methodsFor: 'instance creation' stamp: 'sk 12/22/2011 16:00:59.562'!
widgetColor
	^ Color green! !

!CSAMetric methodsFor: 'accessing' stamp: 'sk 12/22/2011 18:30:18.809'!
classSource
	^ classSource! !

!CSAMetric methodsFor: 'accessing' stamp: 'sk 12/22/2011 19:18:00.488'!
classSource: aCSAClassSource
	classSource := aCSAClassSource.
	self initializeFrom: classSource  
! !

!CSAMetric methodsFor: 'user interface' stamp: 'ck 12/30/2011 16:15:54.776'!
closeWindow
	"self window abandon"! !

!CSAMetric methodsFor: 'user interface' stamp: 'sk 12/21/2011 20:24:08.541'!
createWindow
	self subclassResponsibility! !

!CSAMetric methodsFor: 'initialize-release' stamp: 'sk 12/21/2011 22:53:13.633'!
dismiss
	self closeWindow! !

!CSAMetric methodsFor: 'general handling' stamp: 'sk 12/22/2011 11:43:00.049'!
doDefaultHandlingFor: aCSAEvent
"Default handling is ignoring an event."! !

!CSAMetric methodsFor: 'general handling' stamp: 'sk 12/21/2011 20:47:44.315'!
handle: aCSAEvent
	aCSAEvent accept: self.
	self updateWindow.! !

!CSAMetric methodsFor: 'user interface' stamp: 'sk 12/22/2011 13:08:36.085'!
hideWindow
	self window hide! !

!CSAMetric methodsFor: 'initialize-release' stamp: 'sk 12/22/2011 18:31:55.95'!
initialize
	super initialize.
	^ self
		initializeState;
		window: self createWindow;
		yourself! !

!CSAMetric methodsFor: 'initialize-release' stamp: 'f.z 12/5/2011 16:16:03.751'!
initializeFrom: aClassSource
	self subclassResponsibility  ! !

!CSAMetric methodsFor: 'initialize-release' stamp: 'sk 12/22/2011 18:32:32.35'!
initializeState 
	self sourceMetrics: Dictionary new.! !

!CSAMetric methodsFor: 'user interface' stamp: 'sk 12/22/2011 13:27:01.866'!
openWindow
	self updateWindow.
	self window openInWorld! !

!CSAMetric methodsFor: 'accessing' stamp: 'sk 12/22/2011 18:33:04.461'!
sourceMetrics
	^ sourceMetrics! !

!CSAMetric methodsFor: 'accessing' stamp: 'sk 12/22/2011 18:33:05.295'!
sourceMetrics: aDictionary
	sourceMetrics := aDictionary! !

!CSAMetric methodsFor: 'user interface' stamp: 'sk 12/21/2011 20:48:32.886'!
updateWindow
	self subclassResponsibility! !

!CSAMetric methodsFor: 'accessing' stamp: 'sk 12/21/2011 20:13:09.061'!
window
	^ window! !

!CSAMetric methodsFor: 'accessing' stamp: 'sk 12/21/2011 20:13:09.08'!
window: aCSAMetricWindow
	window := aCSAMetricWindow
! !

CSAMetric subclass: #CSANumberOfClassesMetric
	instanceVariableNames: 'classCount'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CSA-Metrics'!

!CSANumberOfClassesMetric class methodsFor: 'as yet unclassified' stamp: 'sk 12/22/2011 16:03:47.982'!
widgetColor
	^ Color orange! !

!CSANumberOfClassesMetric methodsFor: 'class events' stamp: 'sk 12/22/2011 13:14:40.178'!
addedClass: aCSAClassAddedEvent
	self classCount: self classCount + 1! !

!CSANumberOfClassesMetric methodsFor: 'accessing' stamp: 'sk 12/22/2011 13:13:07.772'!
classCount
	^ classCount! !

!CSANumberOfClassesMetric methodsFor: 'accessing' stamp: 'sk 12/22/2011 13:13:07.817'!
classCount: anInteger
	classCount := anInteger
! !

!CSANumberOfClassesMetric methodsFor: 'user interface' stamp: 'sk 12/22/2011 16:08:25.386'!
createWindow
	^ CSATextWindow labelled: 'NOC' withColor: self class widgetColor! !

!CSANumberOfClassesMetric methodsFor: 'initialize-release' stamp: 'sk 12/22/2011 13:12:51.452'!
initialize
	super initialize.
	self classCount: 0.! !

!CSANumberOfClassesMetric methodsFor: 'initialize-release' stamp: 'sk 12/22/2011 13:13:33.403'!
initializeFrom: aCSAClassSource
	self classCount: aCSAClassSource classes size    ! !

!CSANumberOfClassesMetric methodsFor: 'class events' stamp: 'sk 12/22/2011 13:15:14.415'!
removedClass: aCSAClassRemovedEvent
	self classCount: self classCount - 1! !

!CSANumberOfClassesMetric methodsFor: 'user interface' stamp: 'sk 12/22/2011 13:12:34.695'!
updateWindow
	self window text: 'NOC: ', self classCount! !

CSAMetric subclass: #CSANumberOfMethodsMetric
	instanceVariableNames: 'methodCount'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CSA-Metrics'!

!CSANumberOfMethodsMetric class methodsFor: 'as yet unclassified' stamp: 'sk 12/22/2011 21:04:31.982'!
widgetColor
	^ Color blue muchLighter! !

!CSANumberOfMethodsMetric methodsFor: 'class events' stamp: 'sk 12/22/2011 19:05:35.416'!
addedClass: aCSAClassAddedEvent
	self increaseMethodCountBy: aCSAClassAddedEvent newClass methodDict size  ! !

!CSANumberOfMethodsMetric methodsFor: 'method events' stamp: 'sk 12/22/2011 14:44:36.972'!
addedMethod: aCSAMethodAddedEvent
	self increaseMethodCountBy: 1! !

!CSANumberOfMethodsMetric methodsFor: 'user interface' stamp: 'sk 12/22/2011 16:08:17.688'!
createWindow
	^ CSATextWindow labelled: 'NOM' withColor: self class widgetColor! !

!CSANumberOfMethodsMetric methodsFor: 'observing' stamp: 'sk 12/22/2011 14:43:05.571'!
decreaseMethodCountBy: anInteger
	self increaseMethodCountBy: anInteger negated  ! !

!CSANumberOfMethodsMetric methodsFor: 'as yet unclassified' stamp: 'sk 12/22/2011 14:41:18.518'!
increaseMethodCountBy: anInteger
	self methodCount: self methodCount + anInteger! !

!CSANumberOfMethodsMetric methodsFor: 'initialize-release' stamp: 'sk 12/22/2011 14:35:17.6'!
initialize
	super initialize.
	self methodCount: 0.! !

!CSANumberOfMethodsMetric methodsFor: 'initialize-release' stamp: 'sk 12/22/2011 14:37:27.696'!
initializeFrom: aCSAClassSource
	self methodCount:
		(aCSAClassSource classes
			inject: 0
			into: [ :sum :class | sum + class methodDict size ]  )! !

!CSANumberOfMethodsMetric methodsFor: 'accessing' stamp: 'sk 12/22/2011 14:33:59.378'!
methodCount
	^ methodCount! !

!CSANumberOfMethodsMetric methodsFor: 'accessing' stamp: 'sk 12/22/2011 14:33:59.424'!
methodCount: anInteger
	methodCount := anInteger
! !

!CSANumberOfMethodsMetric methodsFor: 'class events' stamp: 'sk 12/22/2011 21:59:20.527'!
removedClass: aCSARemovedClassEvent
	self decreaseMethodCountBy: aCSARemovedClassEvent removedClass methodDict size  ! !

!CSANumberOfMethodsMetric methodsFor: 'method events' stamp: 'sk 12/22/2011 21:57:20.898'!
removedMethod: aCSAMethodRemovedEvent
	self decreaseMethodCountBy: 1! !

!CSANumberOfMethodsMetric methodsFor: 'user interface' stamp: 'sk 12/22/2011 14:38:10.075'!
updateWindow
	self window text: 'NOM: ', self methodCount! !

CSAMetric subclass: #CSATranscriptMetric
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CSA'!

!CSATranscriptMetric methodsFor: 'event-processing' stamp: 'sk 12/4/2011 22:30:01.074'!
process: anEvent
	Transcript 
		show: '--- Received an event: '; cr; 
		show: anEvent; cr;
		show: '--- End of event';
		cr;
		cr! !

Object subclass: #CSAWidget
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CSA'!

BorderedMorph subclass: #CSAMetricWindow
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CSA-UI'!

!CSAMetricWindow class methodsFor: 'constants' stamp: 'sk 12/21/2011 21:15:18.868'!
extent
	^ 150 @ 100! !

!CSAMetricWindow class methodsFor: 'instance creation' stamp: 'sk 12/22/2011 15:12:58.504'!
labelled: aString withColor: aColor  
	^ self new
		"setLabel: aString;"
		"paneColor: aColor;"
		color: (aColor alpha: 0.8);
		borderColor: aColor muchDarker;  
		yourself! !

!CSAMetricWindow methodsFor: 'initialize-release' stamp: 'sk 12/21/2011 19:33:24.222'!
createWidgets
	self subclassResponsibility! !

!CSAMetricWindow methodsFor: 'initialize-release' stamp: 'sk 12/22/2011 15:03:56.74'!
initialize
	super initialize.
	self
		initializeLayout;
		createWidgets    ! !

!CSAMetricWindow methodsFor: 'initialize-release' stamp: 'sk 12/22/2011 15:59:00.487'!
initializeLayout
	self
		layoutPolicy: TableLayout new; 
		layoutProperties:
			(TableLayoutProperties new
				hResizing: #shrinkWrap;
				vResizing: #shrinkWrap;
				layoutInset: 2;
				yourself)! !

!CSAMetricWindow methodsFor: 'initialize-release' stamp: 'sk 12/22/2011 13:30:22.901'!
openInWorld
	super openInWorld.
	self extent: self class extent.! !

!CSAMetricWindow methodsFor: 'initialize-release' stamp: 'sk 12/22/2011 15:00:15.746'!
wantsRoundedCorners
	^ true! !

CSAMetricWindow subclass: #CSATextWindow
	instanceVariableNames: 'textMorph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CSA-UI'!

!CSATextWindow methodsFor: 'as yet unclassified' stamp: 'sk 12/22/2011 16:06:54.63'!
createWidgets
	self
		textMorph: (TextMorph new 
			backgroundColor: (Color black alpha: 0);
			textColor: Color white;
			yourself);
		addMorph: self textMorph! !

!CSATextWindow methodsFor: 'as yet unclassified' stamp: 'sk 12/21/2011 20:56:47.718'!
text: aStringOrText
	self textMorph contents: aStringOrText! !

!CSATextWindow methodsFor: 'accessing' stamp: 'sk 12/21/2011 20:52:28.571'!
textMorph
	^ textMorph! !

!CSATextWindow methodsFor: 'accessing' stamp: 'sk 12/21/2011 20:52:28.607'!
textMorph: aTextMorph
	textMorph := aTextMorph
! !

TestCase subclass: #CSAEventDispatcherTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CSA-Test'!

!CSAEventDispatcherTest methodsFor: 'filter-testing' stamp: 'f.z 11/30/2011 17:59:09.445'!
testFalseFilter
	| dispatcher |
	dispatcher := CSAEventDispatcher new.
	dispatcher addFilter: CSAFalseFilter new.
	self deny: [ dispatcher isInterestedIn: nil ]! !

!CSAEventDispatcherTest methodsFor: 'filter-testing' stamp: 'f.z 11/30/2011 17:56:04.166'!
testNoFilters
	| dispatcher |
	dispatcher := CSAEventDispatcher new.
	self assert: [ dispatcher isInterestedIn: nil ]! !

!CSAEventDispatcherTest methodsFor: 'filter-testing' stamp: 'f.z 11/30/2011 17:58:10.966'!
testTrueFilter
	| dispatcher |
	dispatcher := CSAEventDispatcher new.
	dispatcher addFilter: CSATrueFilter new.
	self assert: [ dispatcher isInterestedIn: nil ]  ! !

!CSAEventDispatcherTest methodsFor: 'filter-testing' stamp: 'f.z 11/30/2011 17:59:37.35'!
testTwoFilters
	| dispatcher |
	dispatcher := CSAEventDispatcher new.
	dispatcher addFilter: CSAFalseFilter new.
	dispatcher addFilter: CSATrueFilter new.  
	self deny: [ dispatcher isInterestedIn: nil ]! !

TestCase subclass: #CSASingleClassSourceTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CSA-Test'!

!CSASingleClassSourceTest methodsFor: 'as yet unclassified' stamp: 'f.z 1/2/2012 10:31:01.991'!
testGetClasses
	| classes |
	classes := (CSASingleClassSource for: String) classes.
	self assert: classes size == 1.
	self assert: (classes includes: String).! !
